config/routes.rb
Rails.application.routes.draw do

  resources :appointments

  resources :event_pets

  root 'customers#index'

  resources :pets

  resources :pets do
    resources :event_pets
  end

  resources :customers do 
    resources :pets
  end

end

app/models/pet.rb
class Pet < ActiveRecord::Base
  belongs_to :customer
  has_many :event_pets

  validates_presence_of(:name)
  validates_presence_of(:customer)
  
end

app/controllers/pets_controller.rb
class PetsController < ApplicationController
  before_action :set_pet, only: [:show, :edit, :update, :destroy]

  # GET /pets
  # GET /pets.json
  def index
    @pets = Pet.all.order(:name)
  end

  # GET /pets/1
  # GET /pets/1.json
  def show
    @event_pets = @pet.event_pets
  end

  # GET /pets/new
  def new
    @pet = Pet.new
  end

  # GET /pets/1/edit
  def edit
  end

  # POST /pets
  # POST /pets.json
  def create
    @pet = Pet.new(pet_params)

    respond_to do |format|
      if @pet.save
        format.html { redirect_to @pet, notice: 'Huisdier toegevoegd.' }
        format.json { render :show, status: :created, location: @pet }
      else
        format.html { render :new }
        format.json { render json: @pet.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /pets/1
  # PATCH/PUT /pets/1.json
  def update
    respond_to do |format|
      if @pet.update(pet_params)
        format.html { redirect_to @pet, notice: 'Huisdier gewijzigd.' }
        format.json { render :show, status: :ok, location: @pet }
      else
        format.html { render :edit }
        format.json { render json: @pet.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /pets/1
  # DELETE /pets/1.json
  def destroy
    @pet.destroy
    respond_to do |format|
      format.html { redirect_to pets_url, notice: 'Huisdier verwijderd.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_pet
      @pet = Pet.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def pet_params
      params.require(:pet).permit(:species, :name, :pelt, :birthday, :customer_id)
    end
end

app/helpers/pets_helper.rb
module PetsHelper
end

app/views/pets/_form.html.erb
<%= simple_form_for(@pet) do |f| %>
  <%= f.error_notification %>

  <div class="form-inputs">
    <%= f.input :species, label: 'Ras' %>
    <%= f.input :name, label: 'Naam' %>
    <%= f.input :pelt, label: 'Vacht', collection: ["Knippen", "Effileren", "Plukken", "Scheren", "Ontwollen", "Trimloos"], prompt: "Selecteer Vacht" %>
    <%= f.input :birthday, label: 'Geboortedatum' %>
    <%= f.association :customer, label: 'Klant', label_method: "#{:lastname}", prompt: "Selecteer klant" %>
  </div>

  <div class="form-actions">
    <%= f.button :submit %>
  </div>
<% end %>

app/views/pets/edit.html.erb
<div class="page-header">
  <%= link_to pets_path, :class => 'btn btn-default' do %>
    <span class="glyphicon glyphicon-list-alt"></span>
    Terug
  <% end %>
  <%= link_to @pet, :class => 'btn btn-primary' do %>
    <span class="glyphicon glyphicon-info-sign"></span>
    Tonen
  <% end %>
  <h1>Wijzig huisdier</h1>
</div>

<%= render 'form' %>

app/views/pets/index.html.erb
<div class="page-header">
  <%= link_to new_pet_path, :class => 'btn btn-primary' do %>
    <span class="glyphicon glyphicon-plus"></span>
    Nieuw
  <% end %>
  <h1>Huisdieren</h1>
</div>

<div class="table-responsive">
  <table class="table table-striped table-bordered table-hover">
    <thead>
      <tr>
            <th>Ras</th>
            <th>Naam</th>
            <th>Vacht</th>
            <th>Geb. datum</th>
            <th>Klant</th>
            <th></th>
        <th></th>
        <th></th>
      </tr>
    </thead>

    <tbody>
      <%= content_tag_for(:tr, @pets) do |pet| %>
            <td><%= pet.species %></td>
            <td><%= pet.name %></td>
            <td><%= pet.pelt %></td>
            <td><%= pet.birthday.strftime("%d %b %Y") %></td>
            <td><%= pet.customer.lastname %></td>
            <td><%= link_to 'Toon', pet, :class => 'btn btn-xs btn-success' %></td>
        <td><%= link_to 'Wijzig', edit_pet_path(pet), :class => 'btn btn-xs btn-warning' %></td>
        <td><%= link_to 'Verwijder', pet, :class => 'btn btn-xs btn-danger', method: :delete, data: { confirm: 'Are you sure?' } %></td>
      <% end %>
    </tbody>
  </table>
</div>

app/views/pets/new.html.erb
<div class="page-header">
  <%= link_to pets_path, :class => 'btn btn-default' do %>
    <span class="glyphicon glyphicon-list-alt"></span>
    Terug
  <% end %>
  <h1>Nieuw huisdier</h1>
</div>

<%= render 'form' %>

app/views/pets/show.html.erb
<div class="page-header">
  <%= link_to pets_path, :class => 'btn btn-default' do %>
    <span class="glyphicon glyphicon-list-alt"></span>
    Terug
  <% end %>
  <%= link_to edit_pet_path(@pet), :class => 'btn btn-primary' do %>
    <span class="glyphicon glyphicon-pencil"></span>
    Wijzig
  <% end %>
  <h1>Huisdier</h1>
</div>

<dl class="dl-horizontal">

  <dt>Naam:</dt>
  <dd><%= @pet.name %></dd>

  <dt>Soort:</dt>
  <dd><%= @pet.species %></dd>

  <dt>Vacht:</dt>
  <dd><%= @pet.pelt %></dd>

  <dt>Geboortedatum:</dt>
  <dd><%= @pet.birthday.strftime("%d %b %Y") %></dd>

  <dt>Klant:</dt>
  <dd><%= @pet.customer.lastname %></dd>

</dl>

<%= params.inspect %>

<div class="table-responsive">
  <table class="table table-striped table-bordered table-hover">
    <thead>
      <tr>
            <th>Voorval</th>
        <th>Wanneer?</th>
        <th><%= link_to 'Toevoegen', new_pet_event_pet_path(@pet), :class => 'btn btn-xs btn-info' %></th>
      </tr>
    </thead>

    <tbody>
      <%= content_tag_for(:tr, @event_pets) do |event_pet| %>
            <td><%= event_pet.event %></td>
        <td><%= event_pet.date.strftime("%A %d %b %Y") %></td>
        <td><%= link_to 'Verwijder', event_pet, :class => 'btn btn-xs btn-danger', method: :delete, data: { confirm: 'Weet je het zeker?' } %></td>
      <% end %>
    </tbody>
  </table>
</div>